Loading...
Searching...
No Matches
Sip_priority

## Macros

#define | sip_priority(sip)
| Access a SIP Priority header structure sip_priority_t from sip_t.
#define | SIP_PRIORITY_INIT()
| Initializer for structure sip_priority_t.
#define | SIPTAG_PRIORITY(x)
| Tag list item for pointer to a Priority header structure sip_priority_t.
#define | SIPTAG_PRIORITY_REF(x)
| Tag list item for reference to a Priority header pointer.
#define | SIPTAG_PRIORITY_STR(s)
| Tag list item for string with Priority header value.
#define | SIPTAG_PRIORITY_STR_REF(x)
| Tag list item for reference to a Priority header string.

## Typedefs

typedef struct msg_generic_s | sip_priority_t
| @

## Functions

issize_t | sip_priority_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Priority header.
issize_t | sip_priority_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Priority header.
sip_priority_t * | sip_priority_init (sip_priority_t x[1])
| Initialize a structure sip_priority_t.
int | sip_is_priority (sip_header_t const *header)
| Test if header object is instance of sip_priority_t.
sip_priority_t * | sip_priority_dup (su_home_t *home, sip_priority_t const *hdr))
| Duplicate a list of Priority header header structures sip_priority_t.
sip_priority_t * | sip_priority_copy (su_home_t *home, sip_priority_t const *hdr))
| Copy a list of Priority header header structures sip_priority_t.
sip_priority_t * | sip_priority_make (su_home_t *home, char const *s))
| Make a Priority header structure sip_priority_t.
sip_priority_t * | sip_priority_format (su_home_t *home, char const *fmt,...)))
| Make a Priority header from formatting result.

## Variables

msg_hclass_t | sip_priority_class []
| Header class for Priority header.
tag_typedef_t | siptag_priority
| Tag for Priority header object.
tag_typedef_t | siptag_priority_str
| Tag for string with Priority header value.

## Detailed Description

## Macro Definition Documentation

## SIP_PRIORITY_INIT

#define SIP_PRIORITY_INIT | ( |  | ) |

Initializer for structure sip_priority_t.

A static sip_priority_t structure for Priority header must be initialized with the SIP_PRIORITY_INIT() macro. For instance,

sip_priority_t sip_priority = SIP_PRIORITY_INIT;
sip_priority
#define sip_priority(sip)
Access a SIP Priority header structure sip_priority_t from sip_t.
Definition sip_protos.h:5605
sip_priority_t
struct msg_generic_s sip_priority_t
@
Definition sip.h:166
SIP_PRIORITY_INIT
#define SIP_PRIORITY_INIT()
Initializer for structure sip_priority_t.
Definition sip_protos.h:5622

## SIPTAG_PRIORITY

#define SIPTAG_PRIORITY | ( |  | x | ) |

Tag list item for pointer to a Priority header structure sip_priority_t.

The SIPTAG_PRIORITY() macro is used to include a tag item with a pointer to a sip_priority_t structure in a tag list.

Parameters

  x | pointer to a sip_priority_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_PRIORITY_REF().

## SIPTAG_PRIORITY_STR

#define SIPTAG_PRIORITY_STR | ( |  | s | ) |

Tag list item for string with Priority header value.

The SIPTAG_PRIORITY_STR() macro is used to include a tag item with a string containing value of a sip_priority_t header in a tag list.

Parameters

  s | pointer to a string containing Priority header value, or NULL.

The string in SIPTAG_PRIORITY_STR() can be converted to a sip_priority_t header structure by giving the string s has second argument to function sip_priority_make().

The corresponding tag taking reference parameter is SIPTAG_PRIORITY_STR_REF().

## Typedef Documentation

## sip_priority_t

typedef struct msg_generic_s sip_priority_t

@

The Priority request-header field indicates the urgency of the request as perceived by the client. Its syntax is defined in RFC 3261 as follows:

Priority = "Priority" HCOLON priority-value
priority-value = "emergency" / "urgent" / "normal"
/ "non-urgent" / other-priority
other-priority = token

The parsed Priority header is stored in sip_priority_t structure.

The structure sip_priority_t contains representation of a SIP Priority header.

The sip_priority_t is defined as follows:

typedef struct msg_generic_s
{
msg_common_t g_common[1]; // Common fragment info
msg_generic_t *g_next; // Dummy link to next header
char const *g_string; // Priority token
} sip_priority_t;
msg_common_t
struct msg_common_s msg_common_t
msg_generic_s
msg_generic_s::g_common
msg_common_t g_common[1]
msg_generic_s::g_string
char const * g_string
msg_generic_s::g_next
msg_generic_t * g_next

## Function Documentation

## sip_is_priority()

int sip_is_priority | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_priority_t.

Check if the header class is an instance of Priority header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header priority
  0 | (false) otherwise

## sip_priority_copy()

sip_priority_t * sip_priority_copy | ( | su_home_t * | home,
|  | sip_priority_t const * | hdr )

inline

Copy a list of Priority header header structures sip_priority_t.

The function sip_priority_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  priority = sip_priority_copy(home, sip->sip_priority);
  sip_priority_copy
  sip_priority_t * sip_priority_copy(su_home_t *home, sip_priority_t const *hdr))
  Copy a list of Priority header header structures sip_priority_t.
  Definition sip_protos.h:5752

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_priority_dup()

sip_priority_t * sip_priority_dup | ( | su_home_t * | home,
|  | sip_priority_t const * | hdr )

inline

Duplicate a list of Priority header header structures sip_priority_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  priority = sip_priority_dup(home, sip->sip_priority);
  sip_priority_dup
  sip_priority_t * sip_priority_dup(su_home_t *home, sip_priority_t const *hdr))
  Duplicate a list of Priority header header structures sip_priority_t.
  Definition sip_protos.h:5709

Returns
  A pointer to the newly duplicated sip_priority_t header structure, or NULL upon an error.

## sip_priority_format()

sip_priority_t * sip_priority_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Priority header from formatting result.

Make a new sip_priority_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_priority_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_priority_init()

sip_priority_t * sip_priority_init | ( | sip_priority_t | x[1] | ) |

inline

Initialize a structure sip_priority_t.

An sip_priority_t structure for Priority header can be initialized with the sip_priority_init() function/macro. For instance,

sip_priority_t sip_priority;
sip_priority_init(&sip_priority);
sip_priority_init
sip_priority_t * sip_priority_init(sip_priority_t x[1])
Initialize a structure sip_priority_t.
Definition sip_protos.h:5640

## sip_priority_make()

sip_priority_t * sip_priority_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Priority header structure sip_priority_t.

The function sip_priority_make() makes a new sip_priority_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_priority_t header structure, or NULL upon an error.

## Variable Documentation

## sip_priority_class

msg_hclass_t sip_priority_class[]

extern

Header class for Priority header.

The header class sip_priority_class defines how a SIP Priority header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_priority_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.